Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
27 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
28 c3754a5b 2019-05-10 stsp
29 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
30 d3b82051 2022-07-10 thomas
31 d3b82051 2022-07-10 thomas # Check to see if PLATFORM has a value. PLATFORM is populated when running
32 d3b82051 2022-07-10 thomas # via `./configure && make` but this isn't guaranteed if an individual test is
33 d3b82051 2022-07-10 thomas # run directly, such as `regress/cmdline/tag.sh`. In such cases, PLATFORM
34 d3b82051 2022-07-10 thomas # will be empty, but we still want to use it. Since we test for non-linux
35 d3b82051 2022-07-10 thomas # values, only set PLATFORM if we're running on Linu so that the correct
36 d3b82051 2022-07-10 thomas # commands are used.
37 980b1615 2022-07-11 thomas [ -z "$PLATFORM" -a "$(uname)" = "Linux" ] && PLATFORM="linux"
38 7b67836a 2019-05-10 stsp
39 fa37079f 2021-10-09 thomas date()
40 fa37079f 2021-10-09 thomas {
41 fa37079f 2021-10-09 thomas DATECMD="date"
42 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
43 e8da6c41 2022-07-10 thomas command -v "gdate" >/dev/null 2>&1 && {
44 e8da6c41 2022-07-10 thomas DATECMD="gdate"
45 e8da6c41 2022-07-10 thomas } || {
46 cc5596d8 2022-07-11 thomas echo "Couldn't find gdate is GNU coreutils installed?"
47 e8da6c41 2022-07-10 thomas }
48 e8da6c41 2022-07-10 thomas }
49 c206b220 2021-10-09 thomas command "$DATECMD" "$@"
50 fa37079f 2021-10-09 thomas }
51 fa37079f 2021-10-09 thomas
52 fa37079f 2021-10-09 thomas ln()
53 fa37079f 2021-10-09 thomas {
54 fa37079f 2021-10-09 thomas LNCMD="ln"
55 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
56 e8da6c41 2022-07-10 thomas command -v "gln" >/dev/null 2>&1 && {
57 e8da6c41 2022-07-10 thomas LNCMD="gln"
58 e8da6c41 2022-07-10 thomas } || {
59 cc5596d8 2022-07-11 thomas echo "Couldn't find gln is GNU coreutils installed?"
60 e8da6c41 2022-07-10 thomas }
61 e8da6c41 2022-07-10 thomas }
62 c206b220 2021-10-09 thomas command "$LNCMD" "$@"
63 fa37079f 2021-10-09 thomas }
64 fa37079f 2021-10-09 thomas
65 c206b220 2021-10-09 thomas sed()
66 c206b220 2021-10-09 thomas {
67 c206b220 2021-10-09 thomas SEDCMD="sed"
68 186c23b6 2022-03-08 thomas
69 186c23b6 2022-03-08 thomas # On non-linux systems, the sed command can happily accept "-i ''" as
70 186c23b6 2022-03-08 thomas # a valid command to not save backup files for in-place edits.
71 186c23b6 2022-03-08 thomas # However, on linux, "-i ''" would be treated as "-i" with a blank
72 186c23b6 2022-03-08 thomas # argument, and hence, no file to edit in-place, which is an error.
73 186c23b6 2022-03-08 thomas #
74 186c23b6 2022-03-08 thomas # Therefore, scan the argument list and remove "-i ''", replacing it
75 186c23b6 2022-03-08 thomas # with just "-i".
76 432c637b 2022-07-11 thomas
77 1ff9fea4 2021-11-23 thomas [ "$PLATFORM" = "linux" ] && {
78 432c637b 2022-07-11 thomas for w in "$@"
79 432c637b 2022-07-11 thomas do
80 432c637b 2022-07-11 thomas [ "$w" = "-i" ] && {
81 432c637b 2022-07-11 thomas seen=1
82 432c637b 2022-07-11 thomas continue
83 432c637b 2022-07-11 thomas }
84 432c637b 2022-07-11 thomas
85 432c637b 2022-07-11 thomas [ "$seen" = "1" -a -z "$w" ] && {
86 432c637b 2022-07-11 thomas # Move past -i and ''
87 186c23b6 2022-03-08 thomas shift 2
88 432c637b 2022-07-11 thomas
89 0a046396 2022-07-12 thomas command "$SEDCMD" -i "$@"
90 186c23b6 2022-03-08 thomas return
91 186c23b6 2022-03-08 thomas }
92 186c23b6 2022-03-08 thomas done
93 c206b220 2021-10-09 thomas }
94 0a046396 2022-07-12 thomas command "$SEDCMD" "$@"
95 c206b220 2021-10-09 thomas }
96 fa37079f 2021-10-09 thomas
97 fa37079f 2021-10-09 thomas
98 f6cae3ed 2020-09-13 naddy git_init()
99 0e673013 2019-01-02 stsp {
100 0b2899f8 2019-08-18 stsp git init -q "$1"
101 f60607c8 2021-09-30 thomas
102 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
103 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
104 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
105 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
106 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
107 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
108 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
109 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
110 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
111 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
112 0e673013 2019-01-02 stsp }
113 0e673013 2019-01-02 stsp
114 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
115 b32c4525 2020-01-05 stsp {
116 b32c4525 2020-01-05 stsp local repo="$1"
117 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
118 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
119 b32c4525 2020-01-05 stsp fi
120 b32c4525 2020-01-05 stsp }
121 b32c4525 2020-01-05 stsp
122 f6cae3ed 2020-09-13 naddy git_commit()
123 0e673013 2019-01-02 stsp {
124 0e673013 2019-01-02 stsp local repo="$1"
125 0e673013 2019-01-02 stsp shift
126 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
127 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
128 0e673013 2019-01-02 stsp }
129 0e673013 2019-01-02 stsp
130 f6cae3ed 2020-09-13 naddy git_rm()
131 512f0d0e 2019-01-02 stsp {
132 512f0d0e 2019-01-02 stsp local repo="$1"
133 512f0d0e 2019-01-02 stsp shift
134 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
135 512f0d0e 2019-01-02 stsp }
136 512f0d0e 2019-01-02 stsp
137 f6cae3ed 2020-09-13 naddy git_show_head()
138 9c4b8182 2019-01-02 stsp {
139 9c4b8182 2019-01-02 stsp local repo="$1"
140 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
141 9c4b8182 2019-01-02 stsp }
142 9c4b8182 2019-01-02 stsp
143 f6cae3ed 2020-09-13 naddy git_show_branch_head()
144 db32465d 2020-02-07 stsp {
145 db32465d 2020-02-07 stsp local repo="$1"
146 db32465d 2020-02-07 stsp local branch="$2"
147 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
148 db32465d 2020-02-07 stsp }
149 db32465d 2020-02-07 stsp
150 db32465d 2020-02-07 stsp
151 f6cae3ed 2020-09-13 naddy git_show_author_time()
152 bcb49d15 2019-08-14 stsp {
153 bcb49d15 2019-08-14 stsp local repo="$1"
154 01073a5d 2019-08-22 stsp local object="$2"
155 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
156 bcb49d15 2019-08-14 stsp }
157 bcb49d15 2019-08-14 stsp
158 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
159 8e7bd50a 2019-08-22 stsp {
160 8e7bd50a 2019-08-22 stsp local repo="$1"
161 8e7bd50a 2019-08-22 stsp local tag="$2"
162 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
163 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
164 8e7bd50a 2019-08-22 stsp }
165 8e7bd50a 2019-08-22 stsp
166 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
167 818c7501 2019-07-11 stsp {
168 818c7501 2019-07-11 stsp local repo="$1"
169 70551d57 2020-04-24 stsp local commit="$2"
170 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
171 818c7501 2019-07-11 stsp }
172 818c7501 2019-07-11 stsp
173 f6cae3ed 2020-09-13 naddy git_show_tree()
174 03415a1a 2019-06-02 stsp {
175 03415a1a 2019-06-02 stsp local repo="$1"
176 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
177 03415a1a 2019-06-02 stsp }
178 03415a1a 2019-06-02 stsp
179 f6cae3ed 2020-09-13 naddy trim_obj_id()
180 818c7501 2019-07-11 stsp {
181 9439a990 2020-09-16 naddy local trimcount=$1
182 9439a990 2020-09-16 naddy local id=$2
183 818c7501 2019-07-11 stsp
184 9439a990 2020-09-16 naddy local pat=""
185 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
186 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
187 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
188 818c7501 2019-07-11 stsp done
189 818c7501 2019-07-11 stsp
190 818c7501 2019-07-11 stsp echo ${id%$pat}
191 818c7501 2019-07-11 stsp }
192 818c7501 2019-07-11 stsp
193 f6cae3ed 2020-09-13 naddy git_commit_tree()
194 03415a1a 2019-06-02 stsp {
195 03415a1a 2019-06-02 stsp local repo="$1"
196 03415a1a 2019-06-02 stsp local msg="$2"
197 03415a1a 2019-06-02 stsp local tree="$3"
198 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
199 03415a1a 2019-06-02 stsp }
200 03415a1a 2019-06-02 stsp
201 f0fd0aaf 2021-09-14 stsp git_fsck()
202 f0fd0aaf 2021-09-14 stsp {
203 f0fd0aaf 2021-09-14 stsp local testroot="$1"
204 f0fd0aaf 2021-09-14 stsp local repo="$2"
205 f0fd0aaf 2021-09-14 stsp
206 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
207 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
208 fc414659 2022-04-16 thomas ret=$?
209 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
210 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
211 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
212 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
213 f0fd0aaf 2021-09-14 stsp return 1
214 f0fd0aaf 2021-09-14 stsp fi
215 f0fd0aaf 2021-09-14 stsp
216 f0fd0aaf 2021-09-14 stsp return 0
217 f0fd0aaf 2021-09-14 stsp }
218 f0fd0aaf 2021-09-14 stsp
219 f6cae3ed 2020-09-13 naddy make_test_tree()
220 0e673013 2019-01-02 stsp {
221 0e673013 2019-01-02 stsp repo="$1"
222 0e673013 2019-01-02 stsp
223 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
224 0e673013 2019-01-02 stsp echo beta > $repo/beta
225 0e673013 2019-01-02 stsp mkdir $repo/gamma
226 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
227 0e673013 2019-01-02 stsp mkdir $repo/epsilon
228 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
229 0e673013 2019-01-02 stsp }
230 0e673013 2019-01-02 stsp
231 f6cae3ed 2020-09-13 naddy make_single_file_repo()
232 e7303626 2020-05-14 stsp {
233 e7303626 2020-05-14 stsp repo="$1"
234 e7303626 2020-05-14 stsp file="$2"
235 e7303626 2020-05-14 stsp
236 e7303626 2020-05-14 stsp mkdir $repo
237 e7303626 2020-05-14 stsp git_init $repo
238 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
239 e7303626 2020-05-14 stsp (cd $repo && git add .)
240 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
241 e7303626 2020-05-14 stsp }
242 e7303626 2020-05-14 stsp
243 f6cae3ed 2020-09-13 naddy get_loose_object_path()
244 e7303626 2020-05-14 stsp {
245 e7303626 2020-05-14 stsp local repo="$1"
246 e7303626 2020-05-14 stsp local id="$2"
247 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
248 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
249 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
250 e7303626 2020-05-14 stsp }
251 e7303626 2020-05-14 stsp
252 f6cae3ed 2020-09-13 naddy get_blob_id()
253 3ce1b845 2019-07-15 stsp {
254 3ce1b845 2019-07-15 stsp repo="$1"
255 3ce1b845 2019-07-15 stsp tree_path="$2"
256 3ce1b845 2019-07-15 stsp filename="$3"
257 3ce1b845 2019-07-15 stsp
258 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
259 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
260 3ce1b845 2019-07-15 stsp }
261 3ce1b845 2019-07-15 stsp
262 f6cae3ed 2020-09-13 naddy test_init()
263 0e673013 2019-01-02 stsp {
264 0e673013 2019-01-02 stsp local testname="$1"
265 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
266 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
267 0e673013 2019-01-02 stsp echo "No test name provided" >&2
268 0e673013 2019-01-02 stsp return 1
269 0e673013 2019-01-02 stsp fi
270 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
271 0e673013 2019-01-02 stsp mkdir $testroot/repo
272 0e673013 2019-01-02 stsp git_init $testroot/repo
273 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
274 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
275 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
276 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
277 4a1ddfc2 2019-01-12 stsp fi
278 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
279 0e673013 2019-01-02 stsp echo "$testroot"
280 0e673013 2019-01-02 stsp }
281 0e673013 2019-01-02 stsp
282 f6cae3ed 2020-09-13 naddy test_cleanup()
283 0e673013 2019-01-02 stsp {
284 0e673013 2019-01-02 stsp local testroot="$1"
285 fe7842f5 2019-07-14 stsp
286 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
287 fc414659 2022-04-16 thomas ret=$?
288 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
289 f0fd0aaf 2021-09-14 stsp return $ret
290 fe7842f5 2019-07-14 stsp fi
291 fe7842f5 2019-07-14 stsp
292 0e673013 2019-01-02 stsp rm -rf "$testroot"
293 0e673013 2019-01-02 stsp }
294 0e673013 2019-01-02 stsp
295 f6cae3ed 2020-09-13 naddy test_parseargs()
296 7fb414ae 2020-08-08 stsp {
297 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
298 6c8da0c6 2020-10-03 naddy case $flag in
299 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
300 6c8da0c6 2020-10-03 naddy ;;
301 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
302 6c8da0c6 2020-10-03 naddy ;;
303 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
304 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
305 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
306 6c8da0c6 2020-10-03 naddy exit 2
307 6c8da0c6 2020-10-03 naddy ;;
308 7fb414ae 2020-08-08 stsp esac
309 7fb414ae 2020-08-08 stsp done
310 6c8da0c6 2020-10-03 naddy } >&2
311 7fb414ae 2020-08-08 stsp
312 f6cae3ed 2020-09-13 naddy run_test()
313 0e673013 2019-01-02 stsp {
314 0e673013 2019-01-02 stsp testfunc="$1"
315 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
316 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
317 7fb414ae 2020-08-08 stsp fi
318 0e673013 2019-01-02 stsp $testfunc
319 0e673013 2019-01-02 stsp }
320 0e673013 2019-01-02 stsp
321 f6cae3ed 2020-09-13 naddy test_done()
322 0e673013 2019-01-02 stsp {
323 0e673013 2019-01-02 stsp local testroot="$1"
324 0e673013 2019-01-02 stsp local result="$2"
325 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
326 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
327 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
328 7fb414ae 2020-08-08 stsp echo "ok"
329 7fb414ae 2020-08-08 stsp fi
330 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
331 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
332 3941b73a 2019-05-14 stsp echo "$result"
333 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
334 0e673013 2019-01-02 stsp else
335 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
336 0e673013 2019-01-02 stsp fi
337 0e673013 2019-01-02 stsp }